Zee = Zee or {};
Zee.RPPrefix = Zee.RPPrefix or {};
local Win = Zee.WindowAPI;
local RP = Zee.RPPrefix;
RP.Enabled = false;
RP.ButtonText = "Off";
RPPrefix_Settings_New = {}

function RP.LoadSettings()
	RPPrefix_Settings = RPPrefix_Settings or {} -- create table if one doesn't exist
	RPPrefix_Settings_New = RPPrefix_Settings -- assign settings declared above
	if RPPrefix_Settings_New.PreviousPrefix == nil then RPPrefix_Settings_New.PreviousPrefix = "|cFF707070Type prefix here"; end
	 RPPrefix_Settings = RPPrefix_Settings_New;
end

function RP.Toggle()
	-- disable --
	if RP.Enabled then
		RP.Enabled = false;
		for i = 1, NUM_CHAT_WINDOWS do
			getglobal("ChatFrame"..i.."EditBox"):SetScript("OnEnterPressed", function(self) ChatEdit_OnEnterPressed(self) end);
			RP.ButtonText = "Off";
		end
	-- enable --
	else
		RP.Enabled = true;
		for i = 1, NUM_CHAT_WINDOWS do
			getglobal("ChatFrame"..i.."EditBox"):SetScript("OnEnterPressed", function(self) RP.PrefixedChat(self) end);
			RP.ButtonText = "On";
		end
	end
end

function RP.PrefixedChat(frame)
	--ChatFrame1EditBox:SetText(RP.Prefix .. ChatFrame1EditBox:GetText()) 
	for i = 1, NUM_CHAT_WINDOWS do
		local inputText = getglobal("ChatFrame"..i.."EditBox"):GetText();
		local chatType = getglobal("ChatFrame"..i.."EditBox"):GetAttribute("chatType");
		if (chatType == "SAY" or chatType == "YELL") and string.sub(inputText, 0, 1) ~= "/" then
			if inputText ~= "" and inputText ~= nil and RPPrefix_Settings_New.PreviousPrefix ~= "|cFF707070Type prefix here" then
				getglobal("ChatFrame"..i.."EditBox"):SetText(RPPrefix_Settings_New.PreviousPrefix .. " " .. inputText);
			end
		else
			getglobal("ChatFrame"..i.."EditBox"):SetText(inputText);
		end
	end
	ChatEdit_OnEnterPressed(frame) 
end

RP.MainFrame = CreateFrame("Frame", "RPPrefixMainFrame", UIParent);
RP.MainFrame:SetPoint("CENTER", UIParent, "CENTER", 0, 0);
RP.MainFrame:SetSize(200, 20);
RP.MainFrame.texture = RP.MainFrame:CreateTexture("RP-Prefix-MainFrame-Texture", "ARTWORK");
RP.MainFrame.texture:SetColorTexture(0,0,0,0.5);
RP.MainFrame.texture:SetAllPoints(RP.MainFrame);
RP.MainFrame:SetMovable(true);
RP.MainFrame:EnableMouse(true);
RP.MainFrame:RegisterForDrag("LeftButton");
RP.MainFrame:SetScript("OnDragStart", function() RP.MainFrame:StartMoving() end)
RP.MainFrame:SetScript("OnDragStop", function() RP.MainFrame:StopMovingOrSizing() end)

RP.CornerDrag = CreateFrame("Frame", "RPPrefixCornerDrag", RP.MainFrame);
RP.CornerDrag:SetPoint("TOPLEFT", RP.MainFrame, "TOPLEFT", 0, 0);
RP.CornerDrag:SetSize(10, 20);
RP.CornerDrag.texture = RP.CornerDrag:CreateTexture("RP-Prefix-MainFrame-Texture", "ARTWORK");
RP.CornerDrag.texture:SetColorTexture(0.315,0,0,1);
RP.CornerDrag.texture:SetAllPoints(RP.CornerDrag);

RP.Button_Toggle = Win.CreateButton(11, 0, 30, 20, RP.MainFrame, "TOPLEFT", "TOPLEFT", "Off", nil, Win.BUTTON_WOW)
RP.Button_Toggle:SetScript("OnClick", function() RP.Toggle() RP.Button_Toggle.text:SetText(RP.ButtonText) end)

RP.EditBox = CreateFrame('EditBox', "RPPrefixEditbox", RP.MainFrame) ---- left side editable text box
RP.EditBox:SetPoint("TOPRIGHT", RP.MainFrame, "TOPRIGHT", 0, 0)
RP.EditBox:SetAutoFocus(false)
RP.EditBox:EnableMouse(true)
RP.EditBox:SetMaxLetters(20)
RP.EditBox:SetFont('Fonts\\ARIALN.ttf', 12, 'THINOUTLINE')
RP.EditBox:SetScript('OnEscapePressed', function() RP.EditBox:ClearFocus()  end)
RP.EditBox:SetScript('OnEnterPressed', function() RP.EditBox:ClearFocus()  end)
RP.EditBox:EnableMouse()
RP.EditBox:SetScript('OnMouseDown', 
	function() 
		RP.EditBox:SetFocus();
		if RP.EditBox:GetText() == "|cFF707070Type prefix here" then
			RP.EditBox:SetText("");
		end
	end)
RP.EditBox:SetScript("OnTextChanged", 
	function(self,isUserInput) 
		RPPrefix_Settings_New.PreviousPrefix = RP.EditBox:GetText()
		RPPrefix_Settings = RPPrefix_Settings_New;
 	end)
RP.EditBox:SetWidth(155)
RP.EditBox:SetHeight(20)


-- Variables loaded event --
RP.LOGIN_EVENT = CreateFrame("Frame","VARIABLES_LOADED_EVENT_FRAME",UIParent)
RP.LOGIN_EVENT:RegisterEvent("VARIABLES_LOADED");
RP.LOGIN_EVENT:SetScript("OnEvent",
function(self,event,...)
	if event=="VARIABLES_LOADED" then
		RP.LoadSettings();
		RP.LOGIN_EVENT:UnregisterEvent("VARIABLES_LOADED");
		RP.EditBox:SetText(RPPrefix_Settings_New.PreviousPrefix)
	end
end)


----------------------------------------------------------
--	Chat Commands										--
----------------------------------------------------------

function RPPrefixChatCommands(msg, editbox)
	if msg == "reset" then
		RP.MainFrame:ClearAllPoints()
		RP.MainFrame:SetPoint("CENTER", UIParent, "CENTER", 0, 0)
	else
		RPPrefix_Settings_New.PreviousPrefix = msg;
	 	RPPrefix_Settings = RPPrefix_Settings_New;
	 	RP.EditBox:SetText(RPPrefix_Settings_New.PreviousPrefix)
	end
end
SLASH_PREFIX1 = "/prefix";
SlashCmdList["PREFIX"] = RPPrefixChatCommands;